
public class Gradiente
{

	private int width = 1024;
	private int height = 768;
	private int channels = 4;
	public int[][][] imagen;
	
	public static void main(String[] args)
	{
		if(args.length!=3)
		{
			System.out.println("Uso: java Gradiente <width> <height> <channels>");
			System.exit(-1);
		}
		
		int width = Integer.parseInt(args[0]);
		int height = Integer.parseInt(args[1]);
		int channels = Integer.parseInt(args[2]);
		
		Gradiente nuevoGradiente = new Gradiente(width, height, channels);
		nuevoGradiente.gradiente(nuevoGradiente.imagen);
		nuevoGradiente.print();
		
		
	}
	
	public Gradiente(int width, int height, int channels)
	{
		this.width = width;
		this.height = height;
		this.channels = channels;
		
		imagen = new int[width][height][channels];
		
		for(int c=0; c<this.channels; c++)
		{
			
			for(int h=0; h<this.height;h++)
			{
				for(int w=0; w<this.width; w++)
				{
					imagen[w][h][c] = 0;
					
				}	
				
			}	
		}
	}
	
	public void gradiente(int[][][] imagen)
	{
		int celdasPorColor = 0;
		int avance = 1;
		
		celdasPorColor =  (int)Math.ceil((double)this.width/256.0);
		
		if(this.width<256.0)
			avance = (256)/this.width;
		else
			avance = 1;
		
		System.out.println("Avance es "+celdasPorColor);
		int color = 0;
		int opacidad = 255;
		
		for(int w=0; w<this.width; w+=celdasPorColor)
		{
			for(int i=0; i<celdasPorColor; i++)
			{
				for(int h=0; h<this.height;h++)
				{
					imagen[w+i][h][1] = color;
					imagen[w+i][h][3] = opacidad;
					
					
				}
			}
			opacidad-=avance;
			color+=avance;
			
				
		}	
	}
		

	public void print()
	{
		
		for(int c=0; c<this.channels; c++)
		{
			System.out.println("Canal "+(c+1));
			for(int h=0; h<this.height; h++)
			{
				for(int w=0; w<this.width;w++)
				{
					System.out.print(" "+imagen[w][h][c]+" ");
					
				}
				System.out.println("");
				
			}	
		}
	}
	
}
